
package encryptiondemo;
import java.math.BigInteger;


/**
 * <p>Title: Encryption and Decryption Class</p>
 * <p>Description: Ecrypts and decrypts a specific number using the RSA encryption algorythm </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * @author Thomas J Fitzsimmons
 * @version A0.1
 */

public class Encryption {

  public static BigInteger encrypt(BigInteger element, BigInteger e, BigInteger n){
     return element.modPow(e, n);
  }

  public static BigInteger encrypt(int element, int e, int n){
     return encrypt(new BigInteger("" + element), new BigInteger("" + e), new BigInteger("" + n) );
  }

  public static BigInteger decrypt(BigInteger encryptedElement, BigInteger d, BigInteger n){
      return encryptedElement.modPow(d, n);
  }

  public static BigInteger decrypt(int encryptedElement, int d, int n){
     return encrypt(new BigInteger("" + encryptedElement), new BigInteger("" + d), new BigInteger("" + n) );
  }

  public static BigInteger calcD(BigInteger e, BigInteger p, BigInteger q){
     BigInteger x = new BigInteger("" + 0);
     BigInteger q1 = new BigInteger("" + q);
     BigInteger phil = new BigInteger("" + 0);
     BigInteger d = new BigInteger("" + 0);

     q1 = q1.subtract(new BigInteger("" + 1));
     phil = phil.subtract(new BigInteger("" + 1) );
     phil = phil.multiply(new BigInteger("" + q1) );

     return phil.gcd(e);

  }

}