package encryptiondemo;
import java.lang.Character;
import java.math.*;
import javax.swing.*;
/**
 * <p>Title: Encrypt String</p>
 * <p>Description: Encrypts a arbitary length string using the RSA incryption algorythm</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * @author Thomas J. Fitzsimmons
 * @version 2.0
 */

public class EncryptString extends Encryption {

   public static String encryptString(final String message, final long e, final BigInteger n){

      int charInt;
      long encInt = 0;
      char currentChar, encChar;
      int splitNo;
      String toReturn = "", temp = "", temp2 = "", superToReturn = "";

      splitNo = 0;
      int i = 0;
      temp = "0";

      while ( i < n.bitLength()){
         splitNo ++;
         temp += "256";
         i = (new BigInteger(temp)).bitLength();
      }

      splitNo --;

      if(splitNo > 1) splitNo --;

      i = 0;
      temp = "";
      while( i < message.length() ){

         currentChar = message.charAt(i);
         charInt = (new Character(currentChar)).hashCode();
         temp = "" + charInt;

         while(temp.length() < 3){
            temp = 0 + temp;
         }//end while(temp.length() < 5)

         toReturn += temp;

         if ( ((i % splitNo == 0) && (i > 0 )) | splitNo == 1 ){
            //long temp3 = Long.parseLong(toReturn);
            temp2 = encrypt(new BigInteger(toReturn), new BigInteger("" + e), n).toString();
            while(temp2.length() < ((splitNo+1) * 5)){
               temp2 = 0 + temp2;
            }//end while(temp.length() < 5)
            superToReturn = temp2 + superToReturn;
            toReturn = "";
         }

         i++;

      }//end for( int i = 0; i < message.length(); i++)

      if ( toReturn.length() > 0 ){
            temp2 = encrypt(new BigInteger(toReturn), new BigInteger("" + e), n).toString();
            while(temp2.length() < ((splitNo+1) * 5)){
               temp2 = 0 + temp2;
            }//end while(temp.length() < 5)
            superToReturn = temp2 + superToReturn;
            toReturn = "";
      }

      return superToReturn;
   }//end method encrypt(final String message, final int n, final int e)

   public static String decryptString(final String message, final BigInteger d, final BigInteger n){

      long encInt = 0;
      char decChar, encChar;
      String decryptedString = "";
      int length = message.length();
      String encSubString = "";
      String toReturn = "", temp = "";
      String superToReturn = "";
      int j = 0, i = 0, k = 0;

      int splitNo = 0;

      temp = "0";

      while ( i < n.bitLength()){
         splitNo ++;
         temp += "256";
         i = (new BigInteger(temp)).bitLength();

      }
      splitNo --;
      if(splitNo > 1) splitNo --;

      i = 0;
      k = splitNo;
      i = length;
      j = 0;

      while( i > 0 ){
         if( i >= ((splitNo + 1) * 5)) j = i - ((splitNo+1) * 5);
         else j = 0;
         temp = message.substring(j,i);
         decryptedString = decrypt(new BigInteger(temp), d, n) + decryptedString;

         int l = decryptedString.length();
         int m = 0;
         while( l > 0){

            if( l > 2) m = l - 3;
            else m = 0;
            //JOptionPane.showMessageDialog(null, "m : " + m + "m : " + l);
            encSubString = decryptedString.substring(m,l);
            encInt = Integer.parseInt(encSubString);
            decChar = (char)encInt;
            toReturn = decChar + toReturn;
            l = m;
         }//end for( int i = 0; i < message.length(); i++)

         superToReturn += toReturn;
         decryptedString = "";
         toReturn = "";

         i = j;
      }

      return superToReturn;
   }//end method encrypt(final String message, final int n, final int e)
}