package encryptiondemo;
import java.math.*;

/**
 * <p>Title: Maths Libary</p>
 * <p>Description: A class for handling maths, which the standard maths libary can't handle</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * @author Thomas J Fitzsimmons
 * @version 1.0
 */

public class FHMaths {

   public FHMaths() {
   };

   public static boolean isPrime(final BigInteger input){

      return input.isProbablePrime(10);

     /* if( input%2 == 0 )
         return false;

      for(int i = 3; i < (input/2); i++){
         if ( (input % i) == 0 )
            return false;
         i++;
      }
      return true; */
   }

   public static BigInteger generatePrime(final BigInteger startValue){
      BigInteger modStart = new BigInteger("0");
      BigInteger temp = new BigInteger ("0");
      modStart = modStart.add(startValue);
      temp = temp.add(startValue);
      temp = temp.add(new BigInteger("1"));
      temp = temp.mod(new BigInteger("2"));
      modStart = modStart.add(temp);

      while( !isPrime(modStart) ){
         modStart = modStart.add(new BigInteger("2"));
      }
      return modStart;
   }

}